#include <bits/stdc++.h>
using namespace std;

// kvalifikacije 2 19-20
//        pikado
int main()
{
    int n, k;
    cin >> n >> k;

    int popravi = 0;
    map<int, int> meta;
    vector<int> ispis;

    int a;

    if (k > 1) {
        for (int i = 0; i < n; i++) {
            cin >> a;

            if (!meta.count(a))
                meta.insert({a, 1});
            else {
                meta[a]++;
                if (meta[a] >= k) {
                    popravi++;
                    ispis.push_back(a);

                    meta[a] = (0 - n - 1);
                }
            }
        }
    } else
        for (int i = 0; i < n; i++) {
            cin >> a;

            if (!meta.count(a)) {
                meta.insert({a, 1});

                popravi++;
                ispis.push_back(a);
            }
        }

    cout << popravi << "\n";
    for (auto x : ispis)
        cout << x << " ";
}